
//Simple masking shader:
//Takes pixels from the destination layer and uses the red and alpha channels to determine to show the shader's source image


sampler sampler0_ : register(s0);

const float SCREEN_WIDTH = 1024;
const float SCREEN_HEIGHT = 512;

float red = 1;
float blue = 1;
float green = 1;
float alpha = 1;


texture textureMask_;
sampler samplerMask_ = sampler_state{ 
	Texture = <textureMask_>;
};



struct PS_INPUT{
	float4 diffuse : COLOR0;
	float2 texCoord : TEXCOORD0;
	float2 vPos : VPOS;
};


struct PS_OUTPUT{
	float4 color : COLOR0;
};

PS_OUTPUT PsMask( PS_INPUT In ) : COLOR0{
	PS_OUTPUT Out;
	
	float4 colorTexture = tex2D(sampler0_, In.texCoord);
	float4 colorDiffuse = In.diffuse;
	float4 color = colorTexture * colorDiffuse;
	Out.color = color;
	
		float4 colorMask = tex2D(samplerMask_, float2(In.vPos.x, In.vPos.y));

		Out.color.r = colorMask.r*red;
		Out.color.g = colorMask.g*green;
		Out.color.b = colorMask.b*blue;
		Out.color.a = colorMask.a*color.r*alpha;


	return Out;
}



technique TecMask{
	pass P0{
		PixelShader = compile ps_3_0 PsMask();
	}
}